
package android.preference;

import com.tizianhoesch.gibmitnews.database.KlassenlisteDbAdapter;

import android.content.Context;
import android.database.Cursor;
import android.util.AttributeSet;

public class CursorListPreference extends ListPreference {

    private KlassenlisteDbAdapter dbHelperKlasse;
    private Context myContext = this.getContext();

    public CursorListPreference(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public void setData(String inTableName) {
        dbHelperKlasse = new KlassenlisteDbAdapter(myContext);
        dbHelperKlasse.open();

        CharSequence[] lEntries;
        CharSequence[] lEntryValues;

        Cursor lCursor = dbHelperKlasse.fetchAllKlassen();
        if ((lCursor.getCount() == 0) || !lCursor.moveToFirst()) {
            lEntries = new CharSequence[] {};
            lEntryValues = new CharSequence[] {};
        } else {
            lCursor.moveToFirst();
            lEntries = new CharSequence[lCursor.getCount()];
            lEntryValues = new CharSequence[lCursor.getCount()];
            int i = 0;
            do {
                lEntries[i] = lCursor.getString(lCursor
                        .getColumnIndex("klassenkuerzel"));
                lEntryValues[i] = lCursor.getString(lCursor
                        .getColumnIndex("klassenid"));
                ++i;
            } while (lCursor.moveToNext());
        }

        this.setEntries(lEntries);
        this.setEntryValues(lEntryValues);

        dbHelperKlasse.close();
    }
}
