
package com.tizianhoesch.gibmitnews;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.AsyncTask;
import android.widget.Button;
import android.widget.HorizontalScrollView;
import android.widget.LinearLayout.LayoutParams;
import android.widget.ScrollView;
import android.widget.TextView;

public class Agenda extends AsyncTask<Void, Void, String> {
    private String newerererData;
    private Builder dlg;
    private ProgressDialog dialog;
    private TextView textView;

    public Agenda() {
    }

    void onPreExecute(Context ctx) {
        super.onPreExecute();
        ScrollView sv = new ScrollView(ctx);
        sv.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT,
                LayoutParams.MATCH_PARENT));
        HorizontalScrollView hsv = new HorizontalScrollView(ctx);
        hsv.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT,
                LayoutParams.MATCH_PARENT));
        sv.addView(hsv);
        textView = new TextView(ctx);
        textView.setPadding(10, 0, 5, 0);
        hsv.addView(textView);
        Button btn1 = new Button(ctx);
        btn1.setText("OK");
        dlg = new AlertDialog.Builder(ctx);
        dlg.setTitle("Agenda");
        dlg.setNeutralButton("OK", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        dlg.setView(sv);
        dialog = new ProgressDialog(ctx);
        dialog.setMessage("Die Agenda wird geladen...");
        dialog.setCancelable(false);
        dialog.setCanceledOnTouchOutside(false);
        dialog.show();
    }

    @Override
    public void onPostExecute(String unused) {
        textView.setText("Nchste Termine:\n\n" + newerererData);
        dlg.show();
        dialog.dismiss();
    }

    @Override
    protected String doInBackground(Void... params) {
        String url = "http://home.gibm.ch/index.php?id=39&month=0&year=0&kat=all";
        String data;
        data = "FEHLER BEIM BERTRAGEN DER AGENDA!";
        HttpClient httpclient = new DefaultHttpClient();
        HttpGet request = new HttpGet(url);
        int status = 0;
        try {
            HttpResponse response = httpclient.execute(request);
            status = response.getStatusLine().getStatusCode();
            if (status != HttpStatus.SC_OK) {
                ByteArrayOutputStream ostream = new ByteArrayOutputStream();
                response.getEntity().writeTo(ostream);
                data = ostream.toString();
            } else {
                String result = "";

                BufferedReader reader = new BufferedReader(
                        new InputStreamReader(
                                response.getEntity().getContent(),
                                "windows-1252"));

                String line = null;
                while ((line = reader.readLine()) != null) {
                    result += line + "\n";
                }
                data = result;
                reader.close();
            }

            int indexOfStart = data.toString().indexOf("<table");
            int indexOfEnd = data.toString().indexOf("</table>");
            String newData = data.toString().substring(indexOfStart + 417,
                    indexOfEnd + 8);

            String newerData = newData.replaceAll("<li>", "\n");
            String newererData = newerData.replaceAll("<br>", "  ");
            String newererDatas = newererData
                    .replaceAll(
                            "</td><td></td><td valign=\"top\" nowrap></td><td></td><td valign=\"top\">",
                            " ");
            String newererererDatas = newererDatas.replaceAll(
                    "style=\"font-size:0.8em;\">Noteneingabe", "");
            String newererererDatas2 = newererererDatas.replaceAll(
                    "style=\"font-size:0.8em;\">Verwaltung", "");
            String newererererDatas3 = newererererDatas2.replaceAll(
                    "style=\"font-size:0.8em;\">Ferien", "");
            String newererererDatas4 = newererererDatas3.replaceAll(
                    "style=\"font-size:0.8em;\">Sport", "");
            String newererererDatas5 = newererererDatas4.replaceAll(
                    "style=\"font-size:0.8em;\">SCHIWE", "");
            String newererererDatas6 = newererererDatas5.replaceAll(
                    "style=\"font-size:0.8em;\">WB", "");
            String newererererDatas7 = newererererDatas6.replaceAll(
                    "style=\"font-size:0.8em;\">Schulleitung", "");
            String newererererDatas8 = newererererDatas7.replaceAll(
                    "style=\"font-size:0.8em;\">Schulfrei", "");
            String newererererDatas9 = newererererDatas8.replaceAll(
                    "style=\"font-size:0.8em;\">Rektorat", "");
            String newererererDatas10 = newererererDatas9.replaceAll(
                    "style=\"font-size:0.8em;\">LAP", "");
            String newererererDatas11 = newererererDatas10.replaceAll(
                    "style=\"font-size:0.8em;\">KTSI", "");
            String newererererDatas12 = newererererDatas11.replaceAll(
                    "style=\"font-size:0.8em;\">Konvent", "");
            String newererererDatas13 = newererererDatas12.replaceAll(
                    "style=\"font-size:0.8em;\">IT-Abteilung", "");
            String newererererDatas14 = newererererDatas13.replaceAll(
                    "style=\"font-size:0.8em;\">BM", "");
            String newererererDatas15 = newererererDatas14.replaceAll(
                    "style=\"font-size:0.8em;\">Klassensprecher", "");
            String newererererDatas16 = newererererDatas15.replaceAll(
                    "<br><br>", " ");
            String newererererDatas17 = newererererDatas16
                    .replaceAll("  ", " ");
            String newererererDatas18 = newererererDatas17.replaceAll("   ",
                    " ");
            String newererererData = newererererDatas18.replaceAll("\\<.*?>",
                    " ");
            String newerererersData = replaceLast(newererererData,
                    "05.01 - 11.01.2012", "");
            String newererererseData = replaceLast(newerererersData,
                    "Christopher Gutherz", "");
            newerererData = replaceUmlaute(newererererseData);
            return newerererData;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return newerererData;
    }

    /**
     * Ersetzt einen String mit UTF-8 Problemen durch echte Umlaute
     * 
     * @param stringMitUmlauten
     * @return String mit normalen UTF-8 Umlauten
     */
    private String replaceUmlaute(String stringMitUmlauten) {
        stringMitUmlauten = stringMitUmlauten.replaceAll("&auml;", "");
        stringMitUmlauten = stringMitUmlauten.replaceAll("&Auml;", "");
        stringMitUmlauten = stringMitUmlauten.replaceAll("&ouml;", "");
        stringMitUmlauten = stringMitUmlauten.replaceAll("&Ouml;", "");
        stringMitUmlauten = stringMitUmlauten.replaceAll("&uuml;", "");
        stringMitUmlauten = stringMitUmlauten.replaceAll("&Uuml;", "");

        return stringMitUmlauten;
    }

    /**
     * Ersetzt die letzte gefundene Zeichenfolge eines String mit dem gegebenen
     * String
     * 
     * @param text
     * @param regex
     * @param replacement
     * @return String ohne den ersetzten Teil
     */
    private static String replaceLast(String text, String regex,
            String replacement) {
        return text.replaceFirst("(?s)" + regex + "(?!.*?" + regex + ")",
                replacement);
    }
}
