GIBM IT News Android
====================

Dies ist der Source Code der Android App von der IT Abteilung der Gewerblich-industriellen Berufsfachschule Muttenz.



## App Download

[Android Market Download](https://play.google.com/store/apps/details?id=com.tizianhoesch.gibmitnews)



## Beschreibung

Die App zeigt die aktuellen Stundenausfälle und andere News direkt an.
Die News werden, sobald Sie veröffentlicht wurden, auf Ihr Gerät gepusht, um Sie immer auf dem neusten Stand zu halten.
Diese können über eine Pull-to-Refresh oder eine Shake-to-Refresh Funktion aktualisiert werden.
Es können Erinnerungen an verschiedenen Wochentagen zu einer bestimmten Zeit ausgelöst werden, um über am nächsten Schultag eventuelle Stundenausfälle und andere Neuigkeiten informiert zu sein.
Die News können auch in den Zwischenspeicher kopiert oder über viele verschiedene Arten geteilt werden (Facebook, Twitter, Google+, SMS, E-Mail etc.), um so auch Nutzer von anderen Geräten ohne App zu informieren.
Es gibt einige Einstellungen, um die App auf die eigenen Bedürfnisse anzupassen.
Weiterhin kann man einen Beruf und eine Klasse auswählen und danach Stundenpläne für die eigene Klasse abrufen.
Es können alle Berufe, welche an der GIBM angeboten werden, ausgewählt werden, um den Stundenplan von diesen anzuzeigen.
Falls Sie Lehrer sind, wählen Sie beim Typ einfach Lehrer aus, und danach Ihren Namen. Danach können Sie Ihren Stundenplan für die ganze aktuelle Woche anschauen.
Auch gibt es eine Agenda, welche die aktuellen Termine und Veranstaltungen der Schule anzeigt.



## Erklärungen zum Code

Der Code ist nicht komplett auskommentiert und stimmt zum Teil nicht mit den neusten Design Guidelines von Google überein.

Der Code kann beliebig genutzt, verbreitet und neu kompiliert werden, solange die Lizenzen der 3rd Party Bibliotheken nicht verletzt werden.



## Berechtigungen

### android.permission.INTERNET
 Daten (News, Stundenpläne, Agenda etc.) aus dem Internet abrufen
### android.permission.ACCESS_NETWORK_STATE
 Prüfen ob ein Netzwerk (3G, WiFi etc.) vorhanden ist
### android.permission.RECEIVE_BOOT_COMPLETED
 App/Service nach neustart des Gerätes aufstarten
### android.permission.READ_PHONE_STATE
 APID für Push Nachrichten generieren
### android.permission.VIBRATE
 Vibration auslösen
### android.permission.WRITE_EXTERNAL_STORAGE
 Wird von Push Framework benötigt
### com.google.android.c2dm.permission.RECEIVE
 Empfangen von Push Nachrichten
### com.tizianhoesch.gibmitnews.permission.C2D_MESSAGE
 Empfangen von Push Nachrichten
 
 

## Changelog

### Version 1.6
 - Export von Stundenplänen als ICS Datei möglich
 - Neue Pull-To-Refresh ListView
 - Android 4.1 Jelly Bean Support
 - Bug Fixes
 - Code Cleanup
 - Twitter4J 2.2.5 -> 2.2.6
 - UrbanAirShip 1.0.4 -> 1.1.5


### Version 1.5
 - Wochenauswahl in Stundenplan
 - Code Cleanup


### Version 1.4
 - Tablet Support
 - Stundenpläne für Lehrer
 - Stundenpläne für alle Berufe/Klassen der GIBM
 - Agenda horizontal scrollbar
 - Zoom in Stundenplan
 - Push angepasst
 - Schriftgrössen angepasst


### Version 1.3
 - Push Nachrichten
 - Quiet Time für Push Nachrichten
 - Klassenliste wird nun automatisch aktualisiert
 - Links in News können aktiviert werden
 - GIBM Agenda eingefügt
 - Twitter4J 2.2.4 -> 2.2.5
 - Layout Fixes
 - Stundenplan UTF-8 Bug behoben
 - Sekunden aus Zeitstempel entfernt
 - AppRater auf Deutsch übersetzt
 - Bug Fixes
 - Kleine Anpassungen/Änderungen


### Version 1.2
 - Stundenpläne
 - Stabilitäts- und Performance Verbesserungen
 - Android 4.0 ICS Support
 - Bug Fixes
 - Code aufgeräumt


### Version 1.1
 - Offline Cache
 - Bug Fixes
 - Logs optimiert
 - Rate Plugin implementiert


### Version 1.0
 - Erste Version



## Kontakt

[E-Mail](mailto:tizian.hoesch@gmail.com)



## Lizenz

[Apache Version 2.0](http://www.apache.org/licenses/LICENSE-2.0.html)
